$dumpme = 0;
$shrink = 0;
$starturb = 0;

while ($l=<>) {
    chomp $l;
    if ($l =~ />>>/) {
	$mode = 0;
	$capxfrout = 0;
	$xfrdataout = "";
	$xfrdatain = "";
	$urb = $l;
	$urb =~ s/.*URB //;
	$urb =~ s/ .*//;
	$bulk = 0;
	$ep = -1;
    } elsif ($l =~ /<<</) {
	$mode = 1;
    } elsif ($l =~ /USBD_TRANSFER_DIRECTION_OUT/) {
	$capxfrout = 1;
    } elsif ($l =~ /USBD_TRANSFER_DIRECTION_IN/) {
	$capxfrout = 0;
    } elsif ($l =~ /URB_FUNCTION_BULK_OR_INTERRUPT_TRANSFER/) {
	$bulk = 1;
    } elsif ($l =~ /endpoint 0x/) {
	$ep = $l;
	$ep =~ s/.*0x//;
	chop $ep;
	$ep = hex($ep);
    } elsif ($l =~ /TransferBufferLength/) {
	if ( ($mode==0 && $capxfrout==1) || ($mode==1 && $capxfrout==0) ) {
	    ($a,$a,$a,$tbl) = split (/\s+/, $l);
	    $tbl = hex($tbl);
	}
    } elsif ($l =~ /TransferBufferMDL/) {
	if ( $tbl>0 && (($mode==0 && $capxfrout==1) || ($mode==1 && $capxfrout==0) ) ) {
	    $x = "";
	    $lines = int (($tbl+15)/16);
	    for ($i=0; $i<$lines; $i++) {
		$a = <>;
		chomp $a;
		$a =~ s/.*\://;
		$x = $x . $a;
	    }
	    $xfrdataout = $x if ($capxfrout);
	    $xfrdatain = $x if (!$capxfrout);
	}
    } elsif (($l =~ /UrbLink/) && ($mode==1) && ($bulk==1)) {
	if (!($ep & 128)) {
	    $prt = shrink($xfrdataout);
	    print "$urb BW ep($ep) [$tbl]: $prt\n" if ($urb>$starturb);

	    if ($dumpme && $urb>$starturb) {
		$fname = sprintf("bulk/%08d.bin", $urb);
		@bytes=split(/\s+/, $xfrdataout);
		open F, ">$fname";
		for ($i=1; $i<@bytes; $i++) {
		    print F chr(hex($bytes[$i]));
		}
		close F;
	    }
	} else {
	    $ep = $ep & 127;
	    $prt = shrink($xfrdatain);
	    print "$urb BR ep($ep) [$tbl]: $prt\n" if ($urb>$starturb);
	    if ($dumpme && $urb>$starturb) {
		$fname = sprintf("bulk/%08d.bin", $urb);
		@bytes=split(/\s+/, $xfrdatain);
		open F, ">$fname";
		for ($i=1; $i<@bytes; $i++) {
		    print F chr(hex($bytes[$i]));
		}
		close F;
	    }
 
	}
    } elsif ($l =~ /SetupPacket/) {
	$data=<>; chomp $data;
	($a,$b, $d[0], $d[1], $d[2], $d[3], $d[4], $d[5], $d[6], $d[7]) =
	    split (/\s+/, $data);
	$dir = (hex($d[0])) & 128;
	$packet = "$d[0] $d[1] $d[3]$d[2] $d[5]$d[4] $d[7]$d[6]";
	if ($dir==128) {
	    print "$urb CR: $packet : $xfrdatain\n" if ($urb>$starturb);
	} else {
	    print "$urb CW: $packet : $xfrdataout\n" if ($urb>$starturb);
	}
    }




}

sub shrink
{
    my ($in) = @_;
    return $in if (!$shrink);

    my $prt;

    if (length($in)>128) {
	$prt = substr($in,0,60) . " ... " . substr($in, length($in)-59, 60);
    } else {
	$prt = $in;
    }

    return $prt;
}
